#include "gtk/gtk.h"

#include <locale.h>
#include <stdlib.h>  
#include <string.h>

PangoFontDescription *fontlucidagranderegular11;
GdkRGBA WindowBackgroundColor;

GtkWidget *AnzeigeVerlaufWindow;
GtkWidget *AnzeigeVerlaufWindowFixedLayout;
GtkWidget *Label_AnzeigeVerlaufWindowWorking;
GtkWidget *DArea_AnzeigeVerlaufWindowDecoration;

long AnzeigeIntervall;

static gboolean anzeigeverlaufwindowexposeeventcallback (GtkWidget *pwidget, GdkEventExpose *pevent, gpointer pdata)
	{
		cairo_t *lcairo_t;
		
		lcairo_t = gdk_cairo_create (gtk_widget_get_window (GTK_WIDGET(pwidget)));

		cairo_set_source_rgb (lcairo_t, 0.0, 0.0, 0.0);
		cairo_move_to (lcairo_t, 1, 0); cairo_line_to (lcairo_t, 1, 100);
		cairo_stroke (lcairo_t);

		cairo_set_source_rgb (lcairo_t, 1.0, 1.0, 1.0);
		cairo_move_to (lcairo_t, 1, 99); cairo_line_to (lcairo_t, 300, 99);
		cairo_stroke (lcairo_t);

		cairo_set_source_rgb (lcairo_t, 0.3, 0.3, 0.3);
		cairo_move_to (lcairo_t, 2, 0); cairo_line_to (lcairo_t, 2, 99);
		cairo_stroke (lcairo_t);

		cairo_set_source_rgb (lcairo_t, 0.9, 0.9, 0.9);
		cairo_move_to (lcairo_t, 2, 98); cairo_line_to (lcairo_t, 300, 98);
		cairo_stroke (lcairo_t);

		cairo_set_source_rgb (lcairo_t, 0.6, 0.6, 0.6);
		cairo_move_to (lcairo_t, 3, 0); cairo_line_to (lcairo_t, 3, 98);
		cairo_stroke (lcairo_t);

		cairo_set_source_rgb (lcairo_t, 209.0/255.0, 210.0/255.0, 218.0/255.0);
		cairo_move_to (lcairo_t, 3, 97); cairo_line_to (lcairo_t, 300, 97);
		cairo_stroke (lcairo_t);

		cairo_set_source_rgb (lcairo_t, 209.0/255.0, 210.0/255.0, 218.0/255.0);
		cairo_move_to (lcairo_t, 4,  0); cairo_line_to (lcairo_t, 4, 97);
		cairo_stroke (lcairo_t);

		cairo_set_source_rgb (lcairo_t, 0.0, 0.0, 0.0);
		cairo_move_to (lcairo_t, 0, 1); cairo_line_to (lcairo_t, 300, 1);
		cairo_stroke (lcairo_t);

		cairo_set_source_rgb (lcairo_t, 1.0, 1.0, 1.0);
		cairo_move_to (lcairo_t, 299, 1); cairo_line_to (lcairo_t, 299, 100);
		cairo_stroke (lcairo_t);

		cairo_set_source_rgb (lcairo_t, 0.3, 0.3, 0.3);
		cairo_move_to (lcairo_t, 1, 2); cairo_line_to (lcairo_t, 299, 2);
		cairo_stroke (lcairo_t);

		cairo_set_source_rgb (lcairo_t, 0.9, 0.9, 0.9);
		cairo_move_to (lcairo_t, 298, 2); cairo_line_to (lcairo_t, 298, 99);
		cairo_stroke (lcairo_t);

		cairo_set_source_rgb (lcairo_t, 0.6, 0.6, 0.6);
		cairo_move_to (lcairo_t, 2, 3); cairo_line_to (lcairo_t, 298, 3);
		cairo_stroke (lcairo_t);

		cairo_set_source_rgb (lcairo_t, 209.0/255.0, 210.0/255.0, 218.0/255.0);
		cairo_move_to (lcairo_t, 297, 3); cairo_line_to (lcairo_t, 297, 99);
		cairo_stroke (lcairo_t);

		cairo_set_source_rgb (lcairo_t, 209.0/255.0, 210.0/255.0, 218.0/255.0);
		cairo_move_to (lcairo_t, 3, 4); cairo_line_to (lcairo_t, 297, 4);
		cairo_stroke (lcairo_t);

		cairo_destroy (lcairo_t);

		return TRUE;
	}

static void AnzeigeVerlaufAnfang (unsigned int psleep)
	{
		AnzeigeVerlaufWindow = gtk_window_new (GTK_WINDOW_TOPLEVEL);
		gtk_widget_override_background_color (AnzeigeVerlaufWindow, GTK_STATE_FLAG_NORMAL, &WindowBackgroundColor);

		gtk_window_move (GTK_WINDOW (AnzeigeVerlaufWindow), 100, 100);
		gtk_window_resize (GTK_WINDOW(AnzeigeVerlaufWindow), 300, 100);
		gtk_window_set_decorated (GTK_WINDOW (AnzeigeVerlaufWindow), FALSE);

		AnzeigeVerlaufWindowFixedLayout = gtk_fixed_new ();

		DArea_AnzeigeVerlaufWindowDecoration = gtk_drawing_area_new ();
		gtk_widget_set_size_request(DArea_AnzeigeVerlaufWindowDecoration, 300, 100);
		gtk_fixed_put (GTK_FIXED(AnzeigeVerlaufWindowFixedLayout), DArea_AnzeigeVerlaufWindowDecoration, 0, 0);
		g_signal_connect (G_OBJECT (DArea_AnzeigeVerlaufWindowDecoration), "draw", G_CALLBACK (anzeigeverlaufwindowexposeeventcallback), NULL);

		Label_AnzeigeVerlaufWindowWorking = gtk_label_new ("");
		gtk_widget_set_size_request (Label_AnzeigeVerlaufWindowWorking, 300, 0);
		gtk_misc_set_alignment ((GtkMisc *)Label_AnzeigeVerlaufWindowWorking, 0.5, 0.0);
		gtk_fixed_put (GTK_FIXED (AnzeigeVerlaufWindowFixedLayout), Label_AnzeigeVerlaufWindowWorking, 0, 45);

		gtk_container_add (GTK_CONTAINER(AnzeigeVerlaufWindow), AnzeigeVerlaufWindowFixedLayout);

		gtk_widget_show_all (AnzeigeVerlaufWindow);

		gtk_label_set_text (GTK_LABEL (Label_AnzeigeVerlaufWindowWorking), "");

		usleep (psleep);
		while (gtk_events_pending ())
			gtk_main_iteration ();
			
		AnzeigeIntervall = 0;
	}

static void AnzeigeVerlaufAnzeige (char *panzeigetext, unsigned int psleep, long panzeigeintervall)
	{
		AnzeigeIntervall++;
		
		if (panzeigeintervall == AnzeigeIntervall)
			{
				gtk_label_set_text (GTK_LABEL (Label_AnzeigeVerlaufWindowWorking), panzeigetext);

				usleep (psleep);
				while (gtk_events_pending ())
					gtk_main_iteration ();

				AnzeigeIntervall = 0;
			}
	}

static void AnzeigeVerlaufEnde ()
	{
		gtk_widget_destroy (AnzeigeVerlaufWindow);
	}

static void InitiateEnvironment (int argc, char **argv)
	{
		char localbuffer[10005];

		strcpy (localbuffer, argv[0]);
		
		while (localbuffer[strlen(localbuffer)-1] != '/')
			localbuffer[strlen(localbuffer)-1] = '\000';
		
		chdir (localbuffer);

		gtk_init (&argc, &argv);
		g_object_set (gtk_settings_get_default (), "gtk-font-name", "Lucida Grande 8.5", NULL);

		setlocale (LC_NUMERIC, "C");

		fontlucidagranderegular11 = pango_font_description_from_string ("Lucida Grande 7.5");

		WindowBackgroundColor.red = 0.823529411764706;
		WindowBackgroundColor.green = 0.823529411764706;
		WindowBackgroundColor.blue = 0.823529411764706;
		WindowBackgroundColor.alpha = 1.0;
	}

int main (int argc, char **argv)
	{
		long i;
		char lzwbuffer[1001];
	
		InitiateEnvironment (argc, argv);

		AnzeigeVerlaufAnfang (1);

		AnzeigeVerlaufAnzeige ("einfacheintext", 25000, 1);

		for (i=1; i<=1000; i++)
			{
				sprintf (lzwbuffer, "Durchlauf : %ld", i);
				AnzeigeVerlaufAnzeige (lzwbuffer, 25000, 1);
			}

		usleep (5000000);

		AnzeigeVerlaufEnde ();

		return 0;
	}
